#include "CGraphicsException.h"
#include <stdio.h>

//output an unspecified error
CGraphicsException::CGraphicsException() {
	ErrMsg = "<unspecified error>";
}

//output an error with a message from the
//source module.
CGraphicsException::CGraphicsException(char *msg) {
	ErrMsg = msg;
}

//output an error with a message and a line number.
CGraphicsException::CGraphicsException(char *msg, long ln) {
	char *pTmp = new char[ strlen( msg ) + 100 ];
	sprintf(pTmp,"(line: %d) - %s\0",ln,msg);
	ErrMsg = pTmp;
}

//output an error with a message, line number and file name.
CGraphicsException::CGraphicsException(char *msg, char *file, long ln) {
	char *pTmp = new char[ strlen( msg ) + 100 ];
	sprintf( pTmp, "(file: %s, line: %d) - %s\0", file, ln, msg );
	ErrMsg = pTmp;
}

char* CGraphicsException::GetErrMsg() {
	if (ErrMsg != NULL)
		return ErrMsg;
	else
		return NULL;
}

void CGraphicsException::ReportError( ) {

	MessageBox( NULL, ErrMsg, "CGraphicsException", MB_OK | MB_ICONERROR );

}