/*
 *	CGraphicsException.h
 *	Jack Hoxley
 */

#ifndef INC_CGRAPHICSEXCEPTION_H
#define INC_CGRAPHICSEXCEPTION_H

#include <Windows.h>

//when dealing with COM objects (DirectX)
#define SAFE_DELETE(p)       { if(p) { delete (p);     (p)=NULL; } }
#define SAFE_DELETE_ARRAY(p) { if(p) { delete[] (p);   (p)=NULL; } }
#define SAFE_RELEASE(p)      { if(p) { (p)->Release(); (p)=NULL; } }

class CGraphicsException {
private:
	char *ErrMsg;
public:
	CGraphicsException();
	CGraphicsException(char *msg);
	CGraphicsException(char *msg, long ln);
	CGraphicsException(char *msg, char *file, long ln);

	char* GetErrMsg();
	void ReportError();
};

#endif //INC_CGRAPHICSEXCEPTION_H