#ifndef INC_SHADOWCALCULATOR_H
#define INC_SHADOWCALCULATOR_H

#include <d3dx9.h>
#include <stdio.h>
#include "CMesh.h"

#ifndef INC_MSHEDGES
#define INC_MSHEDGES
typedef struct mshEdges {
	D3DXVECTOR3 v1;
	D3DXVECTOR3 v2;
	D3DXVECTOR3 vNorm;
} _mshEdges;
#endif

class ShadowVolume
{
    D3DXVECTOR3 m_pVertices[32000]; // Vertex data for rendering shadow volume
    DWORD       m_dwNumVertices;
	D3DXMATRIX m_matWorld;

	VOID AddEdge( WORD* pEdges, DWORD& dwNumEdges, WORD v0, WORD v1 );

public:
    VOID    Reset();
    HRESULT BuildFromMesh( CMesh* pMeshClass, D3DXVECTOR3 vLight );
    HRESULT Render( LPDIRECT3DDEVICE9 pd3dDevice );
	VOID	SetWorldMatrix( D3DXMATRIX m ) { m_matWorld = m; };
	DWORD	dwTriangles() { return (m_dwNumVertices / 3); };
};

#endif //INC_SHADOWCALCULATOR_H